/*
JAVASCRIPTDATEI fr das Offline-Beitrags-Formular fr CAD.de Mitglieder
Autor    : Rolf "benwisch" Wischnewski
Kontakt  : kontakt@4webwork.de
Homepage : http://www.4webwork.de
Lizenz   : Freeware
*/
// JavaScript Document
function urlTag (_str)
{
/*
Funktion sucht in einem bergebenen String nach Url-Tags
und setzt diese fr eine Html-Vorschau richtig um
*/
var RetVal = "" + _str; // nicht nil !
while (RetVal.indexOf('[URL=')>-1)
{
var posA = RetVal.indexOf('[URL=');
var posE = RetVal.indexOf('[/URL]');
/*
fr einfaches suchen und ersetzen (Erstgefundenes)
klappt es gut mit String.replace
*/
var btw_old = RetVal.substring(posA,posE+6); // den "alten" Stringinhalt dazwischen!!
if (btw_old.indexOf('http://')>-1) // sofern vorh.
{
// .. dann im neuen ndern...
var btw_new = btw_old.replace('[URL=','<a href="');
var btw_new = btw_new.replace(']','" target="_blank">'); // darf nur innerhalb des URL-Tags gesucht werden !!
var btw_new = btw_new.replace('[/URL]','</a>');
// Jetzt kann ich RetVal von alt durch neu ersetzen lassen !
var RetVal = RetVal.replace(btw_old,btw_new);
}
else
{
var RetVal = RetVal.replace(btw_old,'<b><i>{Link prfen!!}</b></i>');
}
}
return(RetVal);
}
//-----------------------------------------------------------------------------------------------------
function cad42Tag (_str)
{
/*
Funktion sucht in einem bergebenen String nach cad42-Fachbegriffen
und setzt diese fr eine Html-Vorschau richtig um
Darberhinaus werden automatisch die Fachbegriffe in Grobuchstaben umgewandelt (cad42.de!)
*/
var RetVal = "" + _str; 
while (RetVal.indexOf('[[')>-1)
{
var posA = RetVal.indexOf('[[');
var posE = RetVal.indexOf(']]');
var btw_old = RetVal.substring(posA,posE+2); // alt festhalten
var what = btw_old.substring(2,btw_old.length -2); // Der Text zwischen [[__]]
var cadlink = "" + ('<a href="http://www.cad42.de/index.php/' + what + '"' + ' target="_blank">');
var btw_new = btw_old.replace('[[',cadlink);
var btw_new = btw_new.replace(']]','</a>').bold().italics().fixed();
var RetVal = RetVal.replace(btw_old,btw_new);
}
return(RetVal);
}
//-----------------------------------------------------------------------------------------------------
function emailTag (_str)
{
/*
Funktion sucht in einem bergebenen String nach email-Tags
und setzt diese fr eine Html-Vorschau richtig um
*/
var RetVal = "" + _str; // nicht nil !
while (RetVal.indexOf('[EMAIL]')>-1)
{
var posA = RetVal.indexOf('[EMAIL]');
var posE = RetVal.indexOf('[/EMAIL]');
var btw_old = RetVal.substring(posA,posE+8); // alt festhalten
if (btw_old.indexOf('@')>-1) // richtige mailangabe ? (einfache Prfung)
{
var em = btw_old.substring(7,btw_old.length -8);
var btw_new = btw_old.replace('[EMAIL]','<a href="mailto:' + em + '" >');
var btw_new = btw_new.replace('[/EMAIL]','</a>');
var RetVal = RetVal.replace(btw_old,btw_new);
}
else // falls nicht, dann auf Fehler in der Vorschau hinweisen!!
{
var RetVal = RetVal.replace(btw_old,'<b><i>{Email prfen!!}</b></i>');
}
}
return(RetVal);
}
//-----------------------------------------------------------------------------------------------------
function subst(_str,_search,_replace)
{
/*
durchsucht einen bergebenen String nach altem Text (_search)
und ersetzt ALLE gefundenen durch neuen Text (_replace)
*/
var RetVal = "" + _str;
while (RetVal.indexOf(_search)>-1) 
{
var pos= RetVal.indexOf(_search);
var RetVal = "" + (RetVal.substring(0, pos) + _replace +
RetVal.substring((pos + _search.length), RetVal.length));
}
return(RetVal);
}

//-----------------------------------------------------------------------------------------------------

function Fenmiddle(x,y) {
var sx = screen.width , sy = screen.height;
x = (sx-x)/2 , y = (sy-y)/2 ;
return new Array(x,y);
}

//-----------------------------------------------------------------------------------------------------
function preview()
{
/*
Erzeugt aus einem Textareafeld mit UBB-Tags eine Vorschau.
Dabei werden alle Tags (hier von www.cad.de) umgesetzt.
Eine Liste wird hier als Standard mit Punktsymbol erzeugt.
*/
if(document.form_name.textarea_name.value.length>0)
{
transformtext = subst(subst(document.form_name.textarea_name.value,'<','&lt;'),'>','&gt;'); // Tagklammern vor(!) <br>
// Zeilentrennsymbol "\n" in Html-Tag <br> umwandeln, sowie
// mind. 2 "normale Leerzeichen" nebeneinander in FESTE umwandeln! Aber nicht ALLE, wg. Zeilenumbruch!!
transformtext = subst(subst(transformtext,'  ','&nbsp;&nbsp;'),'\n','<br>');
// Nun werden die Fachbegriffe durch die Funktion cad42Tag behandelt...
transformtext = cad42Tag(transformtext);
// Anschliessend werden die Url's durch die Funktion urlTag analysiert...
transformtext = urlTag(transformtext);
// Zum Schlu noch Email richtig setzen...
transformtext = emailTag(transformtext);
// Ermittle left und top Koordinate
var xy = Fenmiddle(popX,popY);
// Werte fr das Popup-Fenster...
var wo = "scrollbars=1,menubar=0,status=0,width="+popX+",height="+popY+",left="+xy[0]+",top="+xy[1];
// ffne neues Fenster...
pr=window.open("","",wo);
// schreibe Header...
pr.document.writeln('<html><head><meta http-equiv="content-type" content="text/html; charset=windows-1250"><title>Vorschau fr Benwischs Offline Beitrags-Template f&uuml;r CAD.de Mitglieder<\/title><\/head>');
pr.document.writeln('<style type="text\/css" media="screen"> a:link { color: #000080; text-decoration: none } body a:hover { color: #CC0000; text-decoration: none } a:visited { color: #000080; text-decoration: none } body { margin: 20px; font-family: Arial; background-color: #ffffFF; color: #000000; } <\/style>');
pr.document.writeln('<body>');
transformtext = subst(subst(transformtext,'[b]','<b>'),'[/b]','<\/b>'); // Fett
transformtext = subst(subst(transformtext,'[i]','<i>'),'[/i]','<\/i>'); // Kursiv
transformtext = subst(subst(transformtext,'[list]','<ul>'),'[/list]','<\/ul>'); // Liste
transformtext = subst(subst(transformtext,'[*]','<li>'),'[/*]','<\/li>'); // Liste
transformtext = subst(subst(transformtext,'[IMG]','<img src='),'[/IMG]',' alt="" border=0>'); // Kursiv
transformtext = subst(subst(transformtext,'[QUOTE]','<blockquote><i>Zitat:<\/i><br><hr>'),'[/QUOTE]','<hr><\/blockquote>'); // Zitat
transformtext = subst(subst(transformtext,'[CODE]','<blockquote><i>Code:<\/i><br><hr>'),'[/CODE]','<hr></blockquote>'); // Code
// Setze Smlies...
transformtext = subst(transformtext,':)','<img src=img/smile.gif alt="">');
transformtext = subst(transformtext,';)','<img src=img/zwinker.gif alt="">');
transformtext = subst(transformtext,':lol:','<img src=img/lachen.gif alt="">');
transformtext = subst(transformtext,':D','<img src=img/biggrin.gif alt="">');
transformtext = subst(transformtext,':p','<img src=img/tongue.gif alt="">');
transformtext = subst(transformtext,':eek:','<img src=img/eek.gif alt="">');
transformtext = subst(transformtext,':(','<img src=img/frown.gif alt="">');
transformtext = subst(transformtext,':o','<img src=img/redface.gif alt="">');
transformtext = subst(transformtext,':mad:','<img src=img/mad.gif alt="">');
transformtext = subst(transformtext,':brmbl:','<img src=img/brmbl.gif alt="">');
transformtext = subst(transformtext,':rolleyes:','<img src=img/rolleyes.gif alt="">');
transformtext = subst(transformtext,':confused:','<img src=img/confused.gif alt="">');
transformtext = subst(transformtext,':sleep:','<img src=img/sleep.gif alt="">');
transformtext = subst(transformtext,':cool:','<img src=img/cool.gif alt="">');
transformtext = subst(transformtext,':smokin:','<img src=img/smokin.gif alt="">');
transformtext = subst(transformtext,':wink:','<img src=img/wink.gif alt="">');
transformtext = subst(transformtext,':dance:','<img src=img/dance.gif alt="">');
transformtext = subst(transformtext,':hubbi:','<img src=img/hubbi.gif alt="">');
transformtext = subst(transformtext,':krank:','<img src=img/krank.gif alt="">');
transformtext = subst(transformtext,':heul:','<img src=img/heul.gif alt="">');
transformtext = subst(transformtext,':gemein:','<img src=img/gemein.gif alt="">');
//
pr.document.write(transformtext+'<br>');
// schreibe Footer...
pr.document.write('<br><br><a href="" onClick="JavaScript:window.close()">Fenster schliessen</a>');
pr.document.write('</body></html>');
}
else alert('Keine Vorschau mglich');
}
//-----------------------------------------------------------------------------------------------------
function copy2clipboard()
/*
Kopiert den Inhalt einer Textbox (textarea) in die ZW-Ablage
Klappt aber auch nur mit dem IE :-(
form_name     = Name des Formular (auf Gro- und Kleinschreibung achten!)
textarea_name = Name des Textfeldes TAG = textarea (auf Gro- und Kleinschreibung achten!)
*/
{
if(document.form_name.textarea_name.value.length>0) // Text soll vorh. sein
{
document.form_name.textarea_name.focus();
document.form_name.textarea_name.select();
var sel = document.selection.createRange();
window.clipboardData.setData("Text",sel.text);
}
else alert('Kein Text zum selektieren vorhanden!');
}
//-----------------------------------------------------------------------------------------------------
function checkUBBafter(ubb)
{
if (ubb == "")
return(" ]"); //Leerzeichen, damit Cursorpos. richtig gesetzt wird!
else
return("[/");
}
//-----------------------------------------------------------------------------------------------------
function checkUBBbefore(ubb)
{
if (ubb == "URL")
return("=INTERNETADRESSEHIER]");
else if (ubb == "")
return("[");
else
return("]");
}
//-----------------------------------------------------------------------------------------------------

function InsertMeins (UBBcode)
{
if (document.selection) // fr IE
{
document.form_name.textarea_name.focus();
var sel = document.selection.createRange();
sel.text = UBBcode +  " ";
LoadImg();
return;
}
else // Rest Browser 
{
var txtarea = document.form_name.textarea_name;
var selLength = txtarea.textLength;
var selStart = txtarea.selectionStart;
var selEnd = txtarea.selectionEnd;
if (selEnd == 1 || selEnd == 2)
var selEnd = selLength;
var s1 = (txtarea.value).substring(0,selStart);
var s3 = (txtarea.value).substring(selEnd, selLength);
txtarea.value = s1 + UBBcode + ' ' + s3;
document.form_name.textarea_name.focus();
return;
}
}

//-----------------------------------------------------------------------------------------------------

function InsertUBB(UBBcode)
/*
********************************************************************
Hilfestellung von www.selfhtml.org
********************************************************************
hier : http://aktuell.de.selfhtml.org/tippstricks/javascript/bbcode/
********************************************************************
setzt in einer textarea (hier: textarea_name) innerhalb eines
eines Formulars (hier: form_name) Ubb-Code
Wenn ein Text selektiert ist, wird zwischen diesem Text der UBB-code gesetzt.
Einzige Ausnahme: Opera<V8 -> dort wird jeweils der START-und END-Tag des UBB ans
Ende gesetzt
*/
{
if (document.selection) // fr IE
{
var str = document.selection.createRange().text;
document.form_name.textarea_name.focus();
var sel = document.selection.createRange();
sel.text = "[" + UBBcode + checkUBBbefore(UBBcode) + str + checkUBBafter(UBBcode) + UBBcode + "]";
// Cursorposition in den Tag setzen, wenn nix selektiert ist
if (str.length == 0)
{
var range = document.selection.createRange(); // setze Marke!
range.move('character', -UBBcode.length - 3); // 3 = _[/
range.select(); // positioniere
}
LoadImg();
return;
}
else // Rest Browser ? (getestet Netscape, Firefox und Sonderfall Opera)
{
var txtarea = document.form_name.textarea_name;
var selLength = txtarea.textLength;
var selStart = txtarea.selectionStart;
var selEnd = txtarea.selectionEnd;
if (selEnd == 1 || selEnd == 2)
var selEnd = selLength; // nix selektiert
var s1 = (txtarea.value).substring(0,selStart);
var s2 = (txtarea.value).substring(selStart, selEnd)
var s3 = (txtarea.value).substring(selEnd, selLength);
if ((navigator.userAgent.indexOf("Opera" )) != -1) //wenn Sonderfall OPERA :-(
// hnge UBB-Code an das Ende des gesamten Textes
{
txtarea.value = txtarea.value + '[' + UBBcode + checkUBBbefore(UBBcode) + 'TEXTEINGABE' + checkUBBafter(UBBcode) + UBBcode + ']';
document.form_name.textarea_name.focus();
}
else
{
txtarea.value = s1 + '[' + UBBcode + checkUBBbefore(UBBcode) + s2 + checkUBBafter(UBBcode) + UBBcode + ']' + s3;
document.form_name.textarea_name.focus();
// Cursorposition in den Tag setzen, wenn nix selektiert ist
if (s2.length == 0) {
txtarea.focus(); // setze Marke!
var pos = txtarea.selectionStart - UBBcode.length - 3; // 3 = _[/
txtarea.selectionEnd = pos; // setze Curosr
}
}
return;
}
//else input('[' + UBBcode + '][/' + UBBcode + '] '); // restliche Browser?? (auer Opera)
}
//-----------------------------------------------------------------------------------------------------
function InsertSMI(SMIcode)
/*
Verhlt sich analog wie insertUBBcode, jedoch wird hier
nur einmal ein UBB-Tag gesetzt (fr Smilies und das Listensymbol [*])
*/
{
if (document.form_name.textarea_name.createTextRange)
{
document.form_name.textarea_name.focus();
document.selection.createRange().duplicate().text = SMIcode;
}
else
{
var tarea = document.form_name.textarea_name;
var selEnd = tarea.selectionEnd;
var txtLen = tarea.value.length;
var txtbefore = tarea.value.substring(0,selEnd);
var txtafter = tarea.value.substring(selEnd, txtLen);
if ((navigator.userAgent.indexOf("Opera" )) != -1) //Sonderfall OPERA :-(
tarea.value = tarea.value + SMIcode;
else
tarea.value = txtbefore + SMIcode + txtafter;
}
LoadImg();
}
//-----------------------------------------------------------------------------------------------------

function LoadImg ()
/*
sorgt nach einem Klick auf einem animierten Gif, da alle anderen
Gif's erneut geladen werden, so da die Animation erhalten bleibt!
Dieses Verhalten zeigt sich nur beim IE. Bei Opera und Firefox bleibt
die Animation auch nach einem Klick erhalten.
*/
{
if ((navigator.userAgent.indexOf("MSIE" )) != -1) // fr IE
{
for(i = 0; i < document.images.length; i++) // sammeln aller(!) Grafiken!
if ((document.images[i].src.indexOf('.gif')) != -1)
void(document.images[i].src = document.images[i].src);
}
}

// -----------------------------------------------------------
// KontextMen
// -----------------------------------------------------------

  function showDiv (DivName,x,y) {
  var pos = MouseOffset(DivName,x,y);
  document.getElementById(DivName).style.visibility = "visible";
  document.getElementById(DivName).style.left = pos[0] + "px";
  document.getElementById(DivName).style.top  = pos[1] + "px";
  }   
  
//-----------------------------------------------------------------------------------------------------
  
  function MouseOffset(DivName,xPos,yPos) {
  // var KMwidth  = 100, KMheight = 150;
  if ((navigator.userAgent.indexOf("MSIE" )) != -1)
  {
		if(xPos>KMwidth) xPos=xPos-KMwidth+document.body.scrollLeft;
		else xPos=xPos+document.body.scrollLeft;
		if (yPos>KMheight) yPos=yPos-KMheight+document.body.scrollTop;
		else yPos=yPos+document.body.scrollTop;
	}
	else {
		if(xPos>KMwidth+window.pageXOffset) xPos=xPos-KMwidth;
		if(yPos>KMheight+window.pageYOffset) yPos=yPos-KMheight;
		}
	return new Array(xPos, yPos);
	}
	
//-----------------------------------------------------------------------------------------------------
	  
  function click (e) {
  if (!e)
  e = window.event;
  if ((e.type && e.type == "contextmenu") || (e.button && e.button == 2) || (e.which && e.which == 3)) {
    var xpos = e.clientX;
    var ypos = e.clientY;
    showDiv("KM",xpos,ypos);   
  }
  if (KMorg == 0)
  return false; // ohne das Standard-Kontextmen (Ausnahme Opera)
  }
  
//-----------------------------------------------------------------------------------------------------

  function lengthAsArray (ar){
  var z=0;
  for (i in ar){ z++;}
  return z;
  }
  
//-----------------------------------------------------------------------------------------------------

  function hidd (DivName){
  document.getElementById(DivName).style.visibility = "hidden";
  LoadImg();}
